{{
  Menu Navigation Library  
  ------------------------------------------
  
  Copyright (C) 2008 Gianni Metitieri

   
  Menu Navigation Library is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
   
  Menu Navigation Library Emulator is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
   
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
}}

CON
  _xinfreq      = 10_000_000
  _clkmode      = xtal1 + pll8x
  video         = 24

VAR
byte c
byte keystroke
byte idx
   
OBJ
  TV                  : "TV_Text.spin"
  key                 : "keyboard_iso_010.spin"

PUB Start

  TV.Start(video)
  key.start(3)   
  TV.out($00)

  c := 0
  
  ' display horizontal menu
  HorizMenu

  ' menu navigation
  HorizMenuNavigation




  
PRI HorizMenu

  repeat idx FROM 0 to 5

    MenuID (idx, 0)


PRI HorizMenuNavigation

  MenuID (c, 1) 
  repeat
   
      keystroke := key.getkey

      if keystroke == 193 ' cursor Right
       
          c := c + 1
          
      if keystroke == 192 ' cursor Left
        
          c := c - 1
          
    if c < 0
         
          c := 5
         
    if c > 5
         
          c := 0
          
    HorizMenu
         
    case c
         
      0 : ' RUN
         MenuID (c, 1)
          
      1:  'LOAD
         MenuID (c, 1) 
       
      2:  'SAVE 
         MenuID (c, 1) 
         
      3:  'RESET
         MenuID (c, 1) 
       
      4:  'DEBUG
         MenuID (c, 1) 
       
      5:  'ABOUT
         MenuID (c, 1)  
         

     
PRI MenuID (index, plt) | col

  col := lookupz (index: 0,7,14,21,28,35)
  PrintAt (col,0, @@menuaddr [index], plt)
          

PRI PrintAt(column, row, stringptr,palette )

' column
tv.out($0A)
tv.out(column)

' row
tv.out($0B)
tv.out(row) 

'color palette
tv.out ($0C)
tv.out (palette)

'' Print a zero-terminated string
tv.str(stringptr)

'return to default palette
tv.out ($0C)
tv.out (0)



DAT

menu1   byte "RUN",0
menu2   byte "LOAD",0
menu3   byte "SAVE",0
menu4   byte "RESET",0
menu5   byte "DEBUG",0
menu6   byte "ABOUT",0
menuaddr word @menu1, @menu2, @menu3, @menu4, @menu5, @menu6